// 编写一个程序，创建一个子进程，并在子进程中打印出自己的进程ID（PID），在父进程中打印出子进程的PID。
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char const *argv[])
{
    pid_t pid = fork();
    if (pid < 0)
    {
        printf("fork error\n");
        return -1;
    }
    if (pid == 0)
    {
        printf("子进程打印子进程ID: %d\n", getpid());
    }
    else
    {
        printf("父进程打印子进程ID: %d\n", pid);
    }
    return 0;
}
