使用文档：chat_tool.c

该程序是一个聊天工具，允许两个角色（"lucy" 和 "bob"）之间进行消息的发送和接收。

用法：
./chat_tool [角色名: lucy | bob]

参数说明：

- 角色名：指定聊天的角色，可选的值为 "lucy" 或 "bob"。

注意事项：

- 在运行程序之前，请确保已经创建了相应的 FIFO（命名管道）。
- 创建 FIFO 的函数为 `createFifo(const char *fifoName)`，请确保正确调用该函数。
- FIFO 的名称分别为 "fifo_bob_to_lucy" 和 "fifo_lucy_to_bob"。

示例用法：

1. 创建 FIFO：
   $ ./chat_tool bob
   $ ./chat_tool lucy

2. 运行程序：

   - Bob 方发送消息给 Lucy 方：
     $ ./chat_tool bob

   - Lucy 方发送消息给 Bob 方：
     $ ./chat_tool lucy

3. 聊天操作：
   - 在程序运行后，输入消息并按下回车键发送。
   - 输入 "bye" 退出聊天。

注意事项：

- 请确保在两个不同的终端窗口或会话中分别运行 Bob 方和 Lucy 方。
- Bob 方和 Lucy 方可以同时发送和接收消息。

示例：

- Bob 方发送消息给 Lucy 方：
  $ ./chat_tool bob
  Hello Lucy!
  How are you?
  bye

- Lucy 方发送消息给 Bob 方：
  $ ./chat_tool lucy
  Hi Bob!
  I'm good. How about you?
  bye
