#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char const *argv[])
{
    pid_t pid;

    pid = fork(); // 创建一个子进程
    if (pid < 0)
        perror("fork"); // 如果 fork 失败，打印错误信息
    if (pid == 0)
    {
        // 子进程代码
        while (1)
        {
            printf("这是子进程\n");
            sleep(1); // 休眠 1 秒
        }
    }
    else
    {
        // 父进程代码
        while (1)
        {
            printf("这是父进程\n");
            sleep(1);
        }
    }

    return 0;
}
